﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using RawTouchEvents;
using System.Reflection;

namespace WpfApplication1
{
  public partial class MainWindow : Window
  {
    Dictionary<int, SpinnyControl> controls;

    public MainWindow()
    {
      InitializeComponent();
      this.controls = new Dictionary<int, SpinnyControl>();
    }
    void OnTouchDown(object sender, TouchEventArgs e)
    {
      TouchPoint point = e.GetTouchPoint(this.LayoutRoot);

      SpinnyControl control = new SpinnyControl()
      {
        HorizontalAlignment = HorizontalAlignment.Left,
        VerticalAlignment = VerticalAlignment.Top
      };
      this.controls[e.TouchDevice.Id] = control;
      this.LayoutRoot.Children.Add(control);

      control.RenderTransform = new TranslateTransform()
      {
        X = point.Position.X - (control.Width / 2),
        Y = point.Position.Y - (control.Height) / 2
      };
      e.Handled = true;
    }
    void OnTouchUp(object sender, TouchEventArgs e)
    {
      SpinnyControl control = this.controls[e.TouchDevice.Id];
      this.LayoutRoot.Children.Remove(control);
      e.Handled = true;
    }
    void OnTouchMove(object sender, TouchEventArgs e)
    {
      TouchPoint point = e.GetTouchPoint(this.LayoutRoot);

      SpinnyControl control = this.controls[e.TouchDevice.Id];
      ((TranslateTransform)control.RenderTransform).X =
        point.Position.X - (control.Width / 2);

      ((TranslateTransform)control.RenderTransform).Y =
        point.Position.Y - (control.Height / 2);

      e.Handled = true;
    }
  }
}
